#!/bin/bash

rm -rf /etc/openvpn/crl.pem
cd /usr/share/easy-rsa/2.0/
source vars
./revoke-full $1
chown -R asterisk.asterisk keys

cp -f keys/crl.pem /etc/openvpn/

edited=`cat /etc/openvpn/server.conf | grep "#111crl-verify /etc/openvpn/crl.pem" -c`

if [ $edited == '1'  ] ; then
 sed -i 's/#111crl-verify \/etc\/openvpn\/crl.pem/crl-verify \/etc\/openvpn\/crl.pem/g' /etc/openvpn/server.conf
fi

rm -f /etc/openvpn/clientkeys/$1*
