<?php
include("/var/www/html/libs/misc.lib.php");
include("/var/www/html/configs/default.conf.php");
include("/var/www/html/libs/paloSantoACL.class.php");
include_once("/var/www/html/libs/paloSantoDB.class.php");

session_name("issabelSession");
session_start();
$pDB  = new paloDB($arrConf["issabel_dsn"]["acl"]);
$pACL = new paloACL($pDB);
if(isset($_SESSION["issabel_user"]))
    $issabel_user = $_SESSION["issabel_user"];
else
    $issabel_user = "";
session_commit();
if(!$pACL->isUserAdministratorGroup($issabel_user)){
    $advice = _tr("Unauthorized");
    $msg1 = _tr("You are not authorized to access to this page");
    $msg2 = _tr("You need administrator privileges");
    $template['content']['theme'] = $arrConf['mainTheme'];
    $template['content']['title'] = _tr("Issabel Authentication");
    $template['content']['msg']   =  "<br /><b style='font-size:1.5em;'>$advice</b> <p>$msg1<br/>$msg2</p>";
    extract($template);
    if(file_exists("../issabel_warning_authentication.php"))
       	include("../issabel_warning_authentication.php");
    exit;
}



        $countryname    =$_POST['countryname'];
        $state          =$_POST['state'];
        $locality	=$_POST['locality'];
        $organization   =$_POST['organization'];
        $unitname	=$_POST['unitname'];
        $commonname     =$_POST['commonname'];
        $name           =$_POST['name'];
        $email          =$_POST['email'];


        //if one value is empty display the required label
        if( $countryname==''){
                //$errors1 = '<span class="label label-important">Required</span>'; 
		echo "0";
        }
	elseif( $state==''){
                //$errors1 = '<span class="label label-important">Required</span>'; 
		echo "0";
        }
	elseif( $locality==''){
                //$errors1 = '<span class="label label-important">Required</span>';
		 echo "0";
        }
	elseif( $organization==''){
                //$errors1 = '<span class="label label-important">Required</span>';
		 echo "0";
        }
	elseif( $unitname==''){
                //$errors1 = '<span class="label label-important">Required</span>';
		 echo "0";
        }
	elseif( $commonname==''){
                //$errors1 = '<span class="label label-important">Required</span>';
		echo "0";
        }
	elseif( $name==''){
                //$errors1 = '<span class="label label-important">Required</span>';
		 echo "0";
        }
	elseif( $email==''){
                //$errors1 = '<span class="label label-important">Required</span>';
		 echo "0";

        }else{


			
        	      	//erase the vars file
                	file_put_contents("/usr/share/easy-rsa/2.0/vars", "");

	                //create the new vars File
        	        $fp = fopen("/usr/share/easy-rsa/2.0/vars", "w");
                	fputs($fp,"export EASY_RSA=\"/usr/share/easy-rsa/2.0/\"\n");
	                fputs($fp,"export OPENSSL=\"openssl\"\n");
        	        fputs($fp,"export PKCS11TOOL=\"pkcs11-tool\"\n");
                	fputs($fp,"export GREP=\"grep\"\n");
	                fputs($fp,"export KEY_CONFIG=`/usr/share/easy-rsa/2.0/whichopensslcnf /usr/share/easy-rsa/2.0/`\n");
        	        fputs($fp,"export KEY_DIR=\"/usr/share/easy-rsa/2.0/keys\"\n");
                	fputs($fp,"echo NOTE: If you run ./clean-all, I will be doing a rm -rf on /usr/share/easy-rsa/2.0/keys\n");
	                fputs($fp,"export PKCS11_MODULE_PATH=\"dummy\"\n");
        	        fputs($fp,"export PKCS11_PIN=\"dummy\"\n");
                	fputs($fp,"export KEY_SIZE=1024\n");
	                fputs($fp,"export CA_EXPIRE=3650\n");
        	        fputs($fp,"export KEY_EXPIRE=3650\n");
                	fputs($fp,"");
	                fputs($fp,"export KEY_COUNTRY=\"${countryname}\"\n");
        	        fputs($fp,"export KEY_PROVINCE=\"${state}\"\n");
                	fputs($fp,"export KEY_CITY=\"${locality}\"\n");
	                fputs($fp,"export KEY_ORG=\"${organization}\"\n");
        	        fputs($fp,"export KEY_EMAIL=\"${email}\"\n");
                	fputs($fp,"export KEY_EMAIL=${email}\n");
	                fputs($fp,"export KEY_CN=${commonname}\n");
        	        fputs($fp,"export KEY_NAME=${name}\n");
	                fputs($fp,"export KEY_OU=${unitname}\n");
        	        fputs($fp,"export PKCS11_MODULE_PATH=changeme\n");
                	fputs($fp,"export PKCS11_PIN=1234\n");



			//erase the server settings conf file
                	file_put_contents("/usr/share/easy-rsa/2.0/values_vars", "");

                	//create the new server conf file.
                	$fp = fopen("/usr/share/easy-rsa/2.0/values_vars", "w");
			fputs($fp,"countryname=${countryname}\n");
			fputs($fp,"state=${state}\n");
			fputs($fp,"locality=${locality}\n");
			fputs($fp,"organization=${organization}\n");
			fputs($fp,"unitname=${unitname}\n");
			fputs($fp,"commonname=${commonname}\n");
			fputs($fp,"name=${name}\n");
			fputs($fp,"email=${email}\n");




			//retrieve values to show again
			$valuesc="/usr/share/easy-rsa/2.0/values_vars";

                        if( file_exists($valuesc) ){

	                        $ffvalues = file_get_contents($valuesc);
 
                                preg_match_all("/name=(.*)/i",$ffvalues,$varswname);
                                $countrynameff  =$varswname[1][0];
                                $unitnameff     =$varswname[1][1];
                                $commonnameff   =$varswname[1][2];
                                $nameff         =$varswname[1][3];
 
                                preg_match("/state=(.*)/i",$ffvalues,$state);
                                $stateff        =$state[1];

                                preg_match("/locality=(.*)/i",$ffvalues,$locality);
                                $localityff     =$locality[1];

                                preg_match("/organization=(.*)/i",$ffvalues,$org);
                                $orgff          =$org[1];

                                preg_match("/email=(.*)/i",$ffvalues,$email);
                                $emailff        =$email[1];


				$getvars = array();

				$getvars['countryname'] = $countrynameff;
				$getvars['unitname'] 	= $unitnameff;
				$getvars['commonname'] 	= $commonnameff;
				$getvars['name'] 	= $nameff;
				$getvars['state'] 	= $stateff;
				$getvars['locality'] 	= $localityff;
				$getvars['org'] 	= $orgff;
				$getvars['email'] 	= $emailff;
				$getvars['fileext'] 	= "YES";

				echo __json_encode($getvars);

			}else{
				$getvars = array();

				$getvars['countryname'] = "";
				$getvars['unitname'] 	= "";
				$getvars['commonname'] 	= "";
				$getvars['name'] 	= "";
				$getvars['state'] 	= "";
				$getvars['locality'] 	= "";
				$getvars['org'] 	= "";
				$getvars['email'] 	= "";
				$getvars['fileext'] 	= "";

				echo __json_encode($getvars);

			}



        }





//---------------------------------
function __json_encode( $data ) {
    if( is_array($data) || is_object($data) ) {
        $islist = is_array($data) && ( empty($data) || array_keys($data) === range(0,count($data)-1) );

        if( $islist ) {
            $json = '[' . implode(',', array_map('__json_encode', $data) ) . ']';
        } else {
            $items = Array();
            foreach( $data as $key => $value ) {
                $items[] = __json_encode("$key") . ':' . __json_encode($value);
            }
            $json = '{' . implode(',', $items) . '}';
        }
    } elseif( is_string($data) ) {
        # Escape non-printable or Non-ASCII characters.
        # I also put the \\ character first, as suggested in comments on the 'addclashes' page.
        $string = '"' . addcslashes($data, "\\\"\n\r\t/" . chr(8) . chr(12)) . '"';
        $json    = '';
        $len    = strlen($string);
        # Convert UTF-8 to Hexadecimal Codepoints.
        for( $i = 0; $i < $len; $i++ ) {

            $char = $string[$i];
            $c1 = ord($char);

            # Single byte;
            if( $c1 <128 ) {
                $json .= ($c1 > 31) ? $char : sprintf("\\u%04x", $c1);
                continue;
            }

            # Double byte
            $c2 = ord($string[++$i]);
            if ( ($c1 & 32) === 0 ) {
                $json .= sprintf("\\u%04x", ($c1 - 192) * 64 + $c2 - 128);
                continue;
            }

            # Triple
            $c3 = ord($string[++$i]);
            if( ($c1 & 16) === 0 ) {
                $json .= sprintf("\\u%04x", (($c1 - 224) <<12) + (($c2 - 128) << 6) + ($c3 - 128));
                continue;
            }

            # Quadruple
            $c4 = ord($string[++$i]);
            if( ($c1 & 8 ) === 0 ) {
                $u = (($c1 & 15) << 2) + (($c2>>4) & 3) - 1;

                $w1 = (54<<10) + ($u<<6) + (($c2 & 15) << 2) + (($c3>>4) & 3);
                $w2 = (55<<10) + (($c3 & 15)<<6) + ($c4-128);
                $json .= sprintf("\\u%04x\\u%04x", $w1, $w2);
            }
	}
    } else {
	# int, floats, bools, null
        $json = strtolower(var_export( $data, true ));
    }
    return $json;
}


?>
