<?php
include("/var/www/html/libs/misc.lib.php");
include("/var/www/html/configs/default.conf.php");
include("/var/www/html/libs/paloSantoACL.class.php");
include_once("/var/www/html/libs/paloSantoDB.class.php");

session_name("issabelSession");
session_start();
$pDB  = new paloDB($arrConf["issabel_dsn"]["acl"]);
$pACL = new paloACL($pDB);
if(isset($_SESSION["issabel_user"]))
    $issabel_user = $_SESSION["issabel_user"];
else
    $issabel_user = "";
session_commit();
if(!$pACL->isUserAdministratorGroup($issabel_user)){
    $advice = _tr("Unauthorized");
    $msg1 = _tr("You are not authorized to access to this page");
    $msg2 = _tr("You need administrator privileges");
    $template['content']['theme'] = $arrConf['mainTheme'];
    $template['content']['title'] = _tr("Issabel Authentication");
    $template['content']['msg']   =  "<br /><b style='font-size:1.5em;'>$advice</b> <p>$msg1<br/>$msg2</p>";
    extract($template);
    if(file_exists("../issabel_warning_authentication.php"))
       	include("../issabel_warning_authentication.php");
    exit;
}

        $port =$_POST['port'];
        $ip =$_POST['ip'];
        $adval =$_POST['adval'];
        $protocol =$_POST['protocol'];
        $dev =$_POST['dev'];
        $servernet =$_POST['servernet'];
        $servermask =$_POST['servermask'];
        $keepalivep =$_POST['keepalivep'];
        $keepalivet =$_POST['keepalivet'];


        if( $port==''){
		echo "0";
        }
	elseif( $ip==''){
                echo "0";
        }
	elseif( $protocol==''){
                echo "0";
        }
	elseif( $dev==''){
                echo "0";
        }
	elseif( $servernet==''){
                echo "0";
        }
	elseif( $servermask==''){
                echo "0";
        }
	elseif( $keepalivep==''){
                echo "0";
        }
	elseif( $keepalivet==''){
                echo "0";

        }else{
		

              	//erase the conf file
                file_put_contents("/etc/openvpn/server.conf", "");

                //create the new server conf file.
                $fp = fopen("/etc/openvpn/server.conf", "w");
                fputs($fp,"port ${port}\n");
                fputs($fp,"proto ${protocol}\n");
                fputs($fp,"dev ${dev}\n");
                fputs($fp,"ca ca.crt\n");
                fputs($fp,"cert server.crt\n");
                fputs($fp,"key server.key\n");
                fputs($fp,"dh dh1024.pem\n");
                fputs($fp,"server ${servernet} ${servermask}\n");
                fputs($fp,"ifconfig-pool-persist ipp.txt\n");
                fputs($fp,"keepalive ${keepalivep} ${keepalivet}\n");
                fputs($fp,"comp-lzo\n");
                fputs($fp,"user asterisk\n");
                fputs($fp,"group asterisk\n");
                fputs($fp,"persist-key\n");
                fputs($fp,"persist-tun\n");
                fputs($fp,"status openvpn-status.log\n");
                fputs($fp,"verb 3\n");
                fputs($fp,"client-to-client\n");
                fputs($fp,"#111crl-verify /etc/openvpn/crl.pem\n");
                fputs($fp,"${adval}");


                //erase the server settings conf file
                file_put_contents("/usr/share/easy-rsa/2.0/values_net", "");

                //create the new server conf file.
                $fp = fopen("/usr/share/easy-rsa/2.0/values_net", "w");
                fputs($fp,"port=${port}\n");
                fputs($fp,"proto=${protocol}\n");
                fputs($fp,"dev=${dev}\n");
                fputs($fp,"ip=${ip}\n");
                fputs($fp,"servernet=${servernet}\n");
                fputs($fp,"servermask=${servermask}\n");
                fputs($fp,"keepalivep=${keepalivep}\n");
                fputs($fp,"keepalivet=${keepalivet}\n");
                fputs($fp,"advalbegin:\n${adval}\n:advalends");


							$valuesn='/usr/share/easy-rsa/2.0/values_net';
							$respnet=array();

							if( file_exists('/usr/share/easy-rsa/2.0/values_net') ){

                                                                $fnvalues = file_get_contents($valuesn);
                                                                preg_match("/port=(.*)/i",$fnvalues,$port);
                                                                $portff         =$port[1];

                                                                preg_match("/proto=(.*)/i",$fnvalues,$proto);
                                                                $protoff        =$proto[1];

                                                                preg_match("/dev=(.*)/i",$fnvalues,$dev);
                                                                $devff          =$dev[1];

                                                                preg_match("/ip=(.*)/i",$fnvalues,$ip);
                                                                $ipff           =$ip[1];

                                                                preg_match("/servernet=(.*)/i",$fnvalues,$servernet);
                                                                $servernetff    =$servernet[1];

                                                                preg_match("/servermask=(.*)/i",$fnvalues,$servermask);
                                                                $servermaskff   =$servermask[1];

                                                                preg_match("/keepalivep=(.*)/i",$fnvalues,$keepalivep);
                                                                $keepalivepff   =$keepalivep[1];

                                                                preg_match("/keepalivet=(.*)/i",$fnvalues,$keepalivet);
                                                                $keepalivetff   =$keepalivet[1];

                                                                preg_match("/advalbegin:(.*):advalends/s",$fnvalues,$adval);
                                                                $advalff        =$adval[1];

                                                                $filenet="YES";
								
								$respnet['port']	=$portff;
								$respnet['proto']	=$protoff;
								$respnet['dev']		=$devff;
								$respnet['ip']		=$ipff;
								$respnet['servernet']	=$servernetff;
								$respnet['servermask']	=$servermaskff;
								$respnet['keepalivep']	=$keepalivepff;
								$respnet['keepalivet']	=$keepalivetff;
								$respnet['adval']	=$advalff;
								$respnet['filenet']	=$filenet;



                                                        }else{

                                                                $portff         ='';
                                                                $protoff        ='';
                                                                $devff          ='';
                                                                $ipff           ='';
                                                                $servernetff    ='';
                                                                $servermaskff   ='';
                                                                $keepalivepff   ='';
                                                                $keepalivetff   ='';
                                                                $advalff        ='';
                                                                $filenet="";

								$respnet['port']	=$portff;
								$respnet['proto']	=$protoff;
								$respnet['dev']		=$devff;
								$respnet['ip']		=$ipff;
								$respnet['servernet']	=$servernetff;
								$respnet['servermask']	=$servermaskff;
								$respnet['keepalivep']	=$keepalivepff;
								$respnet['keepalivet']	=$keepalivetff;
								$respnet['adval']	=$advalff;
								$respnet['filenet']	=$filenet;



                                                        }


							if(file_exists('/etc/openvpn/server.conf')){
								$respnet['srvcnf']	="YES";

							}else{
								$respnet['srvcnf']	="";

							}

			echo __json_encode($respnet);
		

        }




//---------------------------------
function __json_encode( $data ) {
    if( is_array($data) || is_object($data) ) {
        $islist = is_array($data) && ( empty($data) || array_keys($data) === range(0,count($data)-1) );

        if( $islist ) {
            $json = '[' . implode(',', array_map('__json_encode', $data) ) . ']';
        } else {
            $items = Array();
            foreach( $data as $key => $value ) {
                $items[] = __json_encode("$key") . ':' . __json_encode($value);
            }
            $json = '{' . implode(',', $items) . '}';
        }
    } elseif( is_string($data) ) {
        # Escape non-printable or Non-ASCII characters.
        # I also put the \\ character first, as suggested in comments on the 'addclashes' page.
        $string = '"' . addcslashes($data, "\\\"\n\r\t/" . chr(8) . chr(12)) . '"';
        $json    = '';
        $len    = strlen($string);
        # Convert UTF-8 to Hexadecimal Codepoints.
        for( $i = 0; $i < $len; $i++ ) {

            $char = $string[$i];
            $c1 = ord($char);

            # Single byte;
            if( $c1 <128 ) {
                $json .= ($c1 > 31) ? $char : sprintf("\\u%04x", $c1);
                continue;
            }

            # Double byte
            $c2 = ord($string[++$i]);
            if ( ($c1 & 32) === 0 ) {
                $json .= sprintf("\\u%04x", ($c1 - 192) * 64 + $c2 - 128);
                continue;
            }

            # Triple
            $c3 = ord($string[++$i]);
            if( ($c1 & 16) === 0 ) {
                $json .= sprintf("\\u%04x", (($c1 - 224) <<12) + (($c2 - 128) << 6) + ($c3 - 128));
                continue;
            }

            # Quadruple
            $c4 = ord($string[++$i]);
            if( ($c1 & 8 ) === 0 ) {
                $u = (($c1 & 15) << 2) + (($c2>>4) & 3) - 1;

                $w1 = (54<<10) + ($u<<6) + (($c2 & 15) << 2) + (($c3>>4) & 3);
                $w2 = (55<<10) + (($c3 & 15)<<6) + ($c4-128);
                $json .= sprintf("\\u%04x\\u%04x", $w1, $w2);
            }
	}
    } else {
	# int, floats, bools, null
        $json = strtolower(var_export( $data, true ));
    }
    return $json;
}

?>
