#!/bin/bash


#Check if the log and status files exist

ipp="/etc/openvpn/ipp.txt"
status="/etc/openvpn/openvpn-status.log"

if [ ! -f "$ipp"  ]; then
	touch $ipp
fi

if [ ! -f "$status"  ]; then
	touch $status
fi


echo
echo
echo "############### LAST SERVER CERT GENERATION ON `date` ###################"
echo

cd /usr/share/easy-rsa/2.0/
source vars
expect  createserver.exp
./build-dh

cp -rf  keys/server.crt /etc/openvpn/
cp -rf  keys/server.key /etc/openvpn/
cp -rf  keys/dh1024.pem /etc/openvpn/
