#!/bin/bash

cd /usr/share/easy-rsa/2.0/


FPATH="/usr/share/easy-rsa/2.0/keys"


if [ -f $FPATH/$1.crt ] && [ -f $FPATH/$1.key ] && [ -f $FPATH/$1.csr  ]; then

port=$(cat values_net | grep port | awk -F"=" '{print $2}' )
ip=$(cat values_net | grep ip | awk -F"=" '{print $2}' )
dev=$(cat values_net | grep dev | awk -F"=" '{print $2}' )
proto=$(cat values_net | grep proto | awk -F"=" '{print $2}' )

echo -e "client" > /etc/openvpn/clientkeys/$1.conf
echo -e "dev $dev" >> /etc/openvpn/clientkeys/$1.conf
echo -e "proto $proto" >> /etc/openvpn/clientkeys/$1.conf
echo -e "remote $ip $port" >> /etc/openvpn/clientkeys/$1.conf
echo -e "resolv-retry infinite" >> /etc/openvpn/clientkeys/$1.conf
echo -e "nobind" >> /etc/openvpn/clientkeys/$1.conf
echo -e "persist-key" >> /etc/openvpn/clientkeys/$1.conf
echo -e "persist-tun" >> /etc/openvpn/clientkeys/$1.conf
echo -e "comp-lzo" >> /etc/openvpn/clientkeys/$1.conf
echo -e "verb 3" >> /etc/openvpn/clientkeys/$1.conf

echo -e "" >> /etc/openvpn/clientkeys/$1.conf
echo -e "<ca>" >> /etc/openvpn/clientkeys/$1.conf
cat /etc/openvpn/ca.crt >> /etc/openvpn/clientkeys/$1.conf
echo -e "</ca>" >> /etc/openvpn/clientkeys/$1.conf

echo -e "" >> /etc/openvpn/clientkeys/$1.conf
echo -e "<cert>" >> /etc/openvpn/clientkeys/$1.conf
sed -n '/^-----BEGIN CERTIFICATE-----$/,/^-----END CERTIFICATE-----/p' keys/$1.crt  >> /etc/openvpn/clientkeys/$1.conf
echo -e "</cert>" >> /etc/openvpn/clientkeys/$1.conf

echo -e "" >> /etc/openvpn/clientkeys/$1.conf
echo -e "<key>" >> /etc/openvpn/clientkeys/$1.conf
cat /usr/share/easy-rsa/2.0/keys/$1.key >> /etc/openvpn/clientkeys/$1.conf
echo -e "</key>" >> /etc/openvpn/clientkeys/$1.conf

 
else

source vars
expect createclient.exp $1

port=$(cat values_net | grep port | awk -F"=" '{print $2}' )
ip=$(cat values_net | grep ip | awk -F"=" '{print $2}' )
dev=$(cat values_net | grep dev | awk -F"=" '{print $2}' )
proto=$(cat values_net | grep proto | awk -F"=" '{print $2}' )

echo -e "client" > /etc/openvpn/clientkeys/$1.conf
echo -e "dev $dev" >> /etc/openvpn/clientkeys/$1.conf
echo -e "proto $proto" >> /etc/openvpn/clientkeys/$1.conf
echo -e "remote $ip $port" >> /etc/openvpn/clientkeys/$1.conf
echo -e "resolv-retry infinite" >> /etc/openvpn/clientkeys/$1.conf
echo -e "nobind" >> /etc/openvpn/clientkeys/$1.conf
echo -e "persist-key" >> /etc/openvpn/clientkeys/$1.conf
echo -e "persist-tun" >> /etc/openvpn/clientkeys/$1.conf
echo -e "comp-lzo" >> /etc/openvpn/clientkeys/$1.conf
echo -e "verb 3" >> /etc/openvpn/clientkeys/$1.conf

echo -e "" >> /etc/openvpn/clientkeys/$1.conf
echo -e "<ca>" >> /etc/openvpn/clientkeys/$1.conf
cat /etc/openvpn/ca.crt >> /etc/openvpn/clientkeys/$1.conf
echo -e "</ca>" >> /etc/openvpn/clientkeys/$1.conf

echo -e "" >> /etc/openvpn/clientkeys/$1.conf
echo -e "<cert>" >> /etc/openvpn/clientkeys/$1.conf
sed -n '/^-----BEGIN CERTIFICATE-----$/,/^-----END CERTIFICATE-----/p' keys/$1.crt  >> /etc/openvpn/clientkeys/$1.conf
echo -e "</cert>" >> /etc/openvpn/clientkeys/$1.conf

echo -e "" >> /etc/openvpn/clientkeys/$1.conf
echo -e "<key>" >> /etc/openvpn/clientkeys/$1.conf
cat /usr/share/easy-rsa/2.0/keys/$1.key >> /etc/openvpn/clientkeys/$1.conf
echo -e "</key>" >> /etc/openvpn/clientkeys/$1.conf

fi
