#!/bin/bash

cd /usr/share/easy-rsa/2.0/

FPATH="/usr/share/easy-rsa/2.0/keys"


if [ -f $FPATH/$1.crt ] && [ -f $FPATH/$1.key ] && [ -f $FPATH/$1.csr  ]; then

	#echo "Existe: $1.crt $1.key $1.csr"

	cp -rf /usr/share/easy-rsa/2.0/keys/$1.crt /etc/openvpn/clientkeys/
       	cp -rf /usr/share/easy-rsa/2.0/keys/$1.key /etc/openvpn/clientkeys/
       	cp -rf /usr/share/easy-rsa/2.0/keys/ca.crt /etc/openvpn/clientkeys/
	

	port=$(cat /usr/share/easy-rsa/2.0/values_net | grep port | awk -F"=" '{print $2}' )
       	ip=$(cat /usr/share/easy-rsa/2.0/values_net | grep ip | awk -F"=" '{print $2}' )
       	dev=$(cat /usr/share/easy-rsa/2.0/values_net | grep dev | awk -F"=" '{print $2}' )
       	proto=$(cat /usr/share/easy-rsa/2.0/values_net | grep proto | awk -F"=" '{print $2}' )

       	echo -e "client" > /etc/openvpn/clientkeys/$1.conf
       	echo -e "dev $dev" >> /etc/openvpn/clientkeys/$1.conf
       	echo -e "proto $proto" >> /etc/openvpn/clientkeys/$1.conf
       	echo -e "remote $ip $port" >> /etc/openvpn/clientkeys/$1.conf
       	echo -e "resolv-retry infinite" >> /etc/openvpn/clientkeys/$1.conf
       	echo -e "nobind" >> /etc/openvpn/clientkeys/$1.conf
       	echo -e "persist-key" >> /etc/openvpn/clientkeys/$1.conf
       	echo -e "persist-tun" >> /etc/openvpn/clientkeys/$1.conf
       	echo -e "ca ca.crt"  >> /etc/openvpn/clientkeys/$1.conf
       	echo -e "cert $1.crt" >> /etc/openvpn/clientkeys/$1.conf
       	echo -e "key $1.key" >> /etc/openvpn/clientkeys/$1.conf
       	echo -e "comp-lzo" >> /etc/openvpn/clientkeys/$1.conf
       	echo -e "verb 3" >> /etc/openvpn/clientkeys/$1.conf


else
	source vars
	expect createclient.exp $1

	cp -rf /usr/share/easy-rsa/2.0/keys/$1.crt /etc/openvpn/clientkeys
	cp -rf /usr/share/easy-rsa/2.0/keys/$1.key /etc/openvpn/clientkeys
	cp -rf /usr/share/easy-rsa/2.0/keys/ca.crt /etc/openvpn/clientkeys



	port=$(cat values_net | grep port | awk -F"=" '{print $2}' )
	ip=$(cat values_net | grep ip | awk -F"=" '{print $2}' )
	dev=$(cat values_net | grep dev | awk -F"=" '{print $2}' )
	proto=$(cat values_net | grep proto | awk -F"=" '{print $2}' )

	echo -e "client" > /etc/openvpn/clientkeys/$1.conf
	echo -e "dev $dev" >> /etc/openvpn/clientkeys/$1.conf
	echo -e "proto $proto" >> /etc/openvpn/clientkeys/$1.conf
	echo -e "remote $ip $port" >> /etc/openvpn/clientkeys/$1.conf
	echo -e "resolv-retry infinite" >> /etc/openvpn/clientkeys/$1.conf
	echo -e "nobind" >> /etc/openvpn/clientkeys/$1.conf
	echo -e "persist-key" >> /etc/openvpn/clientkeys/$1.conf
	echo -e "persist-tun" >> /etc/openvpn/clientkeys/$1.conf
	echo -e "ca ca.crt"  >> /etc/openvpn/clientkeys/$1.conf
	echo -e "cert $1.crt" >> /etc/openvpn/clientkeys/$1.conf
	echo -e "key $1.key" >> /etc/openvpn/clientkeys/$1.conf
	echo -e "comp-lzo" >> /etc/openvpn/clientkeys/$1.conf
	echo -e "verb 3" >> /etc/openvpn/clientkeys/$1.conf
fi

