#!/bin/bash

cd /usr/share/easy-rsa/2.0/

FPATH="/usr/share/easy-rsa/2.0/keys"


if [ -f $FPATH/$1.crt ] && [ -f $FPATH/$1.key ] && [ -f $FPATH/$1.csr  ]; then

mkdir /etc/openvpn/clientkeys/tmp$1


port=$(cat values_net | grep port | awk -F"=" '{print $2}' )
ip=$(cat values_net | grep ip | awk -F"=" '{print $2}' )
dev=$(cat values_net | grep dev | awk -F"=" '{print $2}' )
proto=$(cat values_net | grep proto | awk -F"=" '{print $2}' )


echo -e "client" > /etc/openvpn/clientkeys/tmp$1/vpn.cnf
echo -e "dev $dev" >> /etc/openvpn/clientkeys/tmp$1/vpn.cnf
echo -e "proto $proto" >> /etc/openvpn/clientkeys/tmp$1/vpn.cnf
echo -e "remote $ip $port" >> /etc/openvpn/clientkeys/tmp$1/vpn.cnf
echo -e "resolv-retry infinite" >> /etc/openvpn/clientkeys/tmp$1/vpn.cnf
echo -e "nobind" >> /etc/openvpn/clientkeys/tmp$1/vpn.cnf
echo -e "persist-key" >> /etc/openvpn/clientkeys/tmp$1/vpn.cnf
echo -e "persist-tun" >> /etc/openvpn/clientkeys/tmp$1/vpn.cnf
echo -e "mute-replay-warnings"  >> /etc/openvpn/clientkeys/tmp$1/vpn.cnf
echo -e "ca /openvpn/ca.crt"  >> /etc/openvpn/clientkeys/tmp$1/vpn.cnf
echo -e "cert /openvpn/$1.crt" >> /etc/openvpn/clientkeys/tmp$1/vpn.cnf
echo -e "key /openvpn/$1.key" >> /etc/openvpn/clientkeys/tmp$1/vpn.cnf
echo -e "comp-lzo" >> /etc/openvpn/clientkeys/tmp$1/vpn.cnf
echo -e "verb 0" >> /etc/openvpn/clientkeys/tmp$1/vpn.cnf
echo -e "ns-cert-type server" >> /etc/openvpn/clientkeys/tmp$1/vpn.cnf
echo -e "ping 10" >> /etc/openvpn/clientkeys/tmp$1/vpn.cnf
echo -e "ping-restart 60" >> /etc/openvpn/clientkeys/tmp$1/vpn.cnf


cp -rf /usr/share/easy-rsa/2.0/keys/$1.crt /etc/openvpn/clientkeys/tmp$1
cp -rf /usr/share/easy-rsa/2.0/keys/$1.key /etc/openvpn/clientkeys/tmp$1
cp -rf /usr/share/easy-rsa/2.0/keys/ca.crt /etc/openvpn/clientkeys/tmp$1


cd /etc/openvpn/clientkeys/tmp$1
tar czvf $1.tar vpn.cnf ca.crt $1.*
cp $1.tar ../
cd ..
rm -rf tmp$1



else

source vars
expect createclient.exp $1

mkdir /etc/openvpn/clientkeys/tmp$1


port=$(cat values_net | grep port | awk -F"=" '{print $2}' )
ip=$(cat values_net | grep ip | awk -F"=" '{print $2}' )
dev=$(cat values_net | grep dev | awk -F"=" '{print $2}' )
proto=$(cat values_net | grep proto | awk -F"=" '{print $2}' )


echo -e "client" > /etc/openvpn/clientkeys/tmp$1/vpn.cnf
echo -e "dev $dev" >> /etc/openvpn/clientkeys/tmp$1/vpn.cnf
echo -e "proto $proto" >> /etc/openvpn/clientkeys/tmp$1/vpn.cnf
echo -e "remote $ip $port" >> /etc/openvpn/clientkeys/tmp$1/vpn.cnf
echo -e "resolv-retry infinite" >> /etc/openvpn/clientkeys/tmp$1/vpn.cnf
echo -e "nobind" >> /etc/openvpn/clientkeys/tmp$1/vpn.cnf
echo -e "persist-key" >> /etc/openvpn/clientkeys/tmp$1/vpn.cnf
echo -e "persist-tun" >> /etc/openvpn/clientkeys/tmp$1/vpn.cnf
echo -e "mute-replay-warnings"  >> /etc/openvpn/clientkeys/tmp$1/vpn.cnf
echo -e "ca /openvpn/ca.crt"  >> /etc/openvpn/clientkeys/tmp$1/vpn.cnf
echo -e "cert /openvpn/$1.crt" >> /etc/openvpn/clientkeys/tmp$1/vpn.cnf
echo -e "key /openvpn/$1.key" >> /etc/openvpn/clientkeys/tmp$1/vpn.cnf
echo -e "comp-lzo" >> /etc/openvpn/clientkeys/tmp$1/vpn.cnf
echo -e "verb 0" >> /etc/openvpn/clientkeys/tmp$1/vpn.cnf
echo -e "ns-cert-type server" >> /etc/openvpn/clientkeys/tmp$1/vpn.cnf
echo -e "ping 10" >> /etc/openvpn/clientkeys/tmp$1/vpn.cnf
echo -e "ping-restart 60" >> /etc/openvpn/clientkeys/tmp$1/vpn.cnf


cp -rf /usr/share/easy-rsa/2.0/keys/$1.crt /etc/openvpn/clientkeys/tmp$1
cp -rf /usr/share/easy-rsa/2.0/keys/$1.key /etc/openvpn/clientkeys/tmp$1
cp -rf /usr/share/easy-rsa/2.0/keys/ca.crt /etc/openvpn/clientkeys/tmp$1


cd /etc/openvpn/clientkeys/tmp$1
tar czvf $1.tar vpn.cnf ca.crt $1.*
cp $1.tar ../
cd ..
rm -rf tmp$1

fi
