#!/bin/bash

cd /usr/share/easy-rsa/2.0/

FPATH="/usr/share/easy-rsa/2.0/keys"


if [ -f $FPATH/$1.crt ] && [ -f $FPATH/$1.key ] && [ -f $FPATH/$1.csr  ]; then


port=$(cat values_net | grep port | awk -F"=" '{print $2}' )
ip=$(cat values_net | grep ip | awk -F"=" '{print $2}' )
dev=$(cat values_net | grep dev | awk -F"=" '{print $2}' )
proto=$(cat values_net | grep proto | awk -F"=" '{print $2}' )


echo -e "client" > /etc/openvpn/clientkeys/$1.ovpn
echo -e "dev $dev" >> /etc/openvpn/clientkeys/$1.ovpn
echo -e "proto $proto" >> /etc/openvpn/clientkeys/$1.ovpn
echo -e "remote $ip $port" >> /etc/openvpn/clientkeys/$1.ovpn
echo -e "resolv-retry infinite" >> /etc/openvpn/clientkeys/$1.ovpn
echo -e "nobind" >> /etc/openvpn/clientkeys/$1.ovpn
echo -e "persist-key" >> /etc/openvpn/clientkeys/$1.ovpn
echo -e "persist-tun" >> /etc/openvpn/clientkeys/$1.ovpn
echo -e "ca ca.crt"  >> /etc/openvpn/clientkeys/$1.ovpn
echo -e "cert $1.crt" >> /etc/openvpn/clientkeys/$1.ovpn
echo -e "key $1.key" >> /etc/openvpn/clientkeys/$1.ovpn
echo -e "comp-lzo" >> /etc/openvpn/clientkeys/$1.ovpn
echo -e "verb 3" >> /etc/openvpn/clientkeys/$1.ovpn


cp -rf /usr/share/easy-rsa/2.0/keys/$1.crt /etc/openvpn/clientkeys
cp -rf /usr/share/easy-rsa/2.0/keys/$1.key /etc/openvpn/clientkeys
cp -rf /usr/share/easy-rsa/2.0/keys/ca.crt /etc/openvpn/clientkeys



else

source vars
expect createclient.exp $1


port=$(cat values_net | grep port | awk -F"=" '{print $2}' )
ip=$(cat values_net | grep ip | awk -F"=" '{print $2}' )
dev=$(cat values_net | grep dev | awk -F"=" '{print $2}' )
proto=$(cat values_net | grep proto | awk -F"=" '{print $2}' )


echo -e "client" > /etc/openvpn/clientkeys/$1.ovpn
echo -e "dev $dev" >> /etc/openvpn/clientkeys/$1.ovpn
echo -e "proto $proto" >> /etc/openvpn/clientkeys/$1.ovpn
echo -e "remote $ip $port" >> /etc/openvpn/clientkeys/$1.ovpn
echo -e "resolv-retry infinite" >> /etc/openvpn/clientkeys/$1.ovpn
echo -e "nobind" >> /etc/openvpn/clientkeys/$1.ovpn
echo -e "persist-key" >> /etc/openvpn/clientkeys/$1.ovpn
echo -e "persist-tun" >> /etc/openvpn/clientkeys/$1.ovpn
echo -e "ca ca.crt"  >> /etc/openvpn/clientkeys/$1.ovpn
echo -e "cert $1.crt" >> /etc/openvpn/clientkeys/$1.ovpn
echo -e "key $1.key" >> /etc/openvpn/clientkeys/$1.ovpn
echo -e "comp-lzo" >> /etc/openvpn/clientkeys/$1.ovpn
echo -e "verb 3" >> /etc/openvpn/clientkeys/$1.ovpn


cp -rf /usr/share/easy-rsa/2.0/keys/$1.crt /etc/openvpn/clientkeys
cp -rf /usr/share/easy-rsa/2.0/keys/$1.key /etc/openvpn/clientkeys
cp -rf /usr/share/easy-rsa/2.0/keys/ca.crt /etc/openvpn/clientkeys

fi
