<?php
include("/var/www/html/libs/misc.lib.php");
include("/var/www/html/configs/default.conf.php");
include("/var/www/html/libs/paloSantoACL.class.php");
include_once("/var/www/html/libs/paloSantoDB.class.php");

session_name("issabelSession");
session_start();
$pDB  = new paloDB($arrConf["issabel_dsn"]["acl"]);
$pACL = new paloACL($pDB);
if(isset($_SESSION["issabel_user"]))
    $issabel_user = $_SESSION["issabel_user"];
else
    $issabel_user = "";
session_commit();
if(!$pACL->isUserAdministratorGroup($issabel_user)){
    $advice = _tr("Unauthorized");
    $msg1 = _tr("You are not authorized to access to this page");
    $msg2 = _tr("You need administrator privileges");
    $template['content']['theme'] = $arrConf['mainTheme'];
    $template['content']['title'] = _tr("Issabel Authentication");
    $template['content']['msg']   =  "<br /><b style='font-size:1.5em;'>$advice</b> <p>$msg1<br/>$msg2</p>";
    extract($template);
    if(file_exists("../issabel_warning_authentication.php"))
       	include("../issabel_warning_authentication.php");
    exit;
}





	exec("sed -n '/^Virtual/,/^GLOBAL/p' /etc/openvpn/openvpn-status.log | sed '1d' | sed '$ d' > /etc/openvpn/cclients.txt");
	function get_rows() {
		$i = 0;
		$file=fopen("/etc/openvpn/cclients.txt",'r');
		while($line = fgets($file)){//while we can still read the file
			$i++;
			$line=trim($line);//remove the line endings and extra white-spaces at start and end
			list($virtualip,$name,$realip) = explode(',',$line);//you get an array of 4 per line, first item is author, etc...
			echo "<tr class='alert alert-info'><td>$virtualip</td><td>$name</td><td>$realip</td><td><button value='$name-rev' class='btn btn-warning revokecert'>Revoke</button></td></tr>\n";//use the \n to clean up the source a code a bit to make it readable
		}
		return true;
	}

	
	exec("cat /usr/share/easy-rsa/2.0/keys/index.txt | grep '^R' | awk -F'/' '{print $7}' | awk -F'=' '{print $2}' > /etc/openvpn/revokedclients.txt");
	function get_rows2() {
		$i = 0;
		$file=fopen("/etc/openvpn/revokedclients.txt",'r');
		while($line = fgets($file)){//while we can still read the file
			$i++;
			$line=trim($line);//remove the line endings and extra white-spaces at start and end
			list($name) = explode(',',$line);//you get an array of 4 per line, first item is author, etc...
			echo "<tr><td class='alert alert-error'><b>$name</b></td></tr>\n";//use the \n to clean up the source a code a bit to make it readable
		}
		return true;
	}



	exec("cat /usr/share/easy-rsa/2.0/keys/index.txt | grep '^V' | awk -F'/' '{print $7}' | awk -F'=' '{print $2}' > /etc/openvpn/allclients.txt");
	function get_rows3() {
		$i = 0;
		$file=fopen("/etc/openvpn/allclients.txt",'r');
		while($line = fgets($file)){//while we can still read the file
			$i++;
			$line=trim($line);//remove the line endings and extra white-spaces at start and end
			list($name) = explode(',',$line);//you get an array of 4 per line, first item is author, etc...
			echo "<tr><td><b>$name</b></td><td><button value='$name-rev' class='btn btn-warning revokecert'>Revoke</button></td></tr>\n";//use the \n to clean up the source a code a bit to make it readable
		}
		return true;
	}




	echo '	
		<div class="box-header well span5" data-original-title="">
			<h3>Connected Clients</h3><br>
			<table class="table table-stripped table-condensed">
				<th>Virtual IP</th>				
				<th>Common Name</th>				
				<th>Real IP</th>				
				<th>Revoke</th>				
				<tbody>';
					  get_rows();
	echo '			</tbody>				
			</table>

		</div>';




	 $validcerts=exec("cat /usr/share/easy-rsa/2.0/keys/index.txt | grep -c '^V'");


        echo '	
              	<div class="box-header well span3" data-original-title="">
                        <h3>Created Certificates: '.$validcerts.'</h3><br>
                        <table class="table table-stripped table-condensed">
                                <th>Name</th>
                                <th>Revoke</th>
                                <tbody>';
                                          get_rows3();

        echo '                  </tbody>
                        </table>

                </div>';




        $revcerts=exec("cat /usr/share/easy-rsa/2.0/keys/index.txt | grep -c '^R'");


        echo '
              	<div class="box-header well span2" data-original-title="">
                        <h3>Revoked Clients: '.$revcerts.'</h3><br>
                        <table class="table table-stripped table-condensed">
                                <th>Name</th>
                                <tbody>';
                                          get_rows2();

        echo '                  </tbody>
                        </table>

                </div>';

		




?>

