<?php
include("/var/www/html/libs/misc.lib.php");
include("/var/www/html/configs/default.conf.php");
include("/var/www/html/libs/paloSantoACL.class.php");
include_once("/var/www/html/libs/paloSantoDB.class.php");

session_name("issabelSession");
session_start();
$pDB  = new paloDB($arrConf["issabel_dsn"]["acl"]);
$pACL = new paloACL($pDB);
if(isset($_SESSION["issabel_user"]))
    $issabel_user = $_SESSION["issabel_user"];
else
    $issabel_user = "";
session_commit();
if(!$pACL->isUserAdministratorGroup($issabel_user)){
    $advice = _tr("Unauthorized");
    $msg1 = _tr("You are not authorized to access to this page");
    $msg2 = _tr("You need administrator privileges");
    $template['content']['theme'] = $arrConf['mainTheme'];
    $template['content']['title'] = _tr("Issabel Authentication");
    $template['content']['msg']   =  "<br /><b style='font-size:1.5em;'>$advice</b> <p>$msg1<br/>$msg2</p>";
    extract($template);
    if(file_exists("../issabel_warning_authentication.php"))
       	include("../issabel_warning_authentication.php");
    exit;
}



        $clean    =$_POST['clean'];

	if( $clean==''){
		 echo "0";

        }else{
		 
		exec("bash /usr/share/easy-rsa/2.0/clean.sh");

                $fileca=array();


		if(file_exists('/usr/share/easy-rsa/2.0/keys/ca.crt') && file_exists('/etc/openvpn/ca.crt') && file_exists('/etc/openvpn/server.key') && file_exists('/etc/openvpn/server.crt')){

                        $createdca="YES";
			$fileca['caexist']	= $createdca;
                        

                }else{
                      	$createdca="";                    
			 $fileca['caexist']	= $createdca;                        

                }


		if(file_exists('/etc/openvpn/server.key') && file_exists('/etc/openvpn/server.crt')){
                
			$srvkey="YES";
                        $srvcrt="YES";

			 $fileca['srvkey']	= $srvkey;
			 $fileca['srvcrt']	= $srvcrt;

                }else{
                       	$srvkey="";
                        $srvcrt="";

			 $fileca['srvkey']	= $srvkey;
			 $fileca['srvcrt']	= $srvcrt;

                }

               	if(file_exists('/etc/openvpn/dh1024.pem')){
                        $filedh="YES";
			 $fileca['filedh']	= $filedh;

               	}else{
                        $filedh="";
			 $fileca['filedh']	= $filedh;


      	        }

		echo __json_encode($fileca);



        }

//---------------------------------
function __json_encode( $data ) {
    if( is_array($data) || is_object($data) ) {
        $islist = is_array($data) && ( empty($data) || array_keys($data) === range(0,count($data)-1) );

        if( $islist ) {
            $json = '[' . implode(',', array_map('__json_encode', $data) ) . ']';
        } else {
            $items = Array();
            foreach( $data as $key => $value ) {
                $items[] = __json_encode("$key") . ':' . __json_encode($value);
            }
            $json = '{' . implode(',', $items) . '}';
        }
    } elseif( is_string($data) ) {
        # Escape non-printable or Non-ASCII characters.
        # I also put the \\ character first, as suggested in comments on the 'addclashes' page.
        $string = '"' . addcslashes($data, "\\\"\n\r\t/" . chr(8) . chr(12)) . '"';
        $json    = '';
        $len    = strlen($string);
        # Convert UTF-8 to Hexadecimal Codepoints.
        for( $i = 0; $i < $len; $i++ ) {

            $char = $string[$i];
            $c1 = ord($char);

            # Single byte;
            if( $c1 <128 ) {
                $json .= ($c1 > 31) ? $char : sprintf("\\u%04x", $c1);
                continue;
            }

            # Double byte
            $c2 = ord($string[++$i]);
            if ( ($c1 & 32) === 0 ) {
                $json .= sprintf("\\u%04x", ($c1 - 192) * 64 + $c2 - 128);
                continue;
            }

            # Triple
            $c3 = ord($string[++$i]);
            if( ($c1 & 16) === 0 ) {
                $json .= sprintf("\\u%04x", (($c1 - 224) <<12) + (($c2 - 128) << 6) + ($c3 - 128));
                continue;
            }

            # Quadruple
            $c4 = ord($string[++$i]);
            if( ($c1 & 8 ) === 0 ) {
                $u = (($c1 & 15) << 2) + (($c2>>4) & 3) - 1;

                $w1 = (54<<10) + ($u<<6) + (($c2 & 15) << 2) + (($c3>>4) & 3);
                $w2 = (55<<10) + (($c3 & 15)<<6) + ($c4-128);
                $json .= sprintf("\\u%04x\\u%04x", $w1, $w2);
            }
	}
    } else {
	# int, floats, bools, null
        $json = strtolower(var_export( $data, true ));
    }
    return $json;
}


?>

