
<?php
include("/var/www/html/libs/misc.lib.php");
include("/var/www/html/configs/default.conf.php");
include("/var/www/html/libs/paloSantoACL.class.php");
include_once("/var/www/html/libs/paloSantoDB.class.php");

session_name("issabelSession");
session_start();
$pDB  = new paloDB($arrConf["issabel_dsn"]["acl"]);
$pACL = new paloACL($pDB);
if(isset($_SESSION["issabel_user"])) {
    $issabel_user = $_SESSION["issabel_user"];
} else {
    $issabel_user = "";
}
session_commit();

if(!$pACL->isUserAdministratorGroup($issabel_user)){
    $advice = _tr("Unauthorized");
    $msg1 = _tr("You are not authorized to access to this page");
    $msg2 = _tr("You need administrator privileges");
    $template['content']['theme'] = $arrConf['mainTheme'];
    $template['content']['title'] = _tr("Issabel Authentication");
    $template['content']['msg']   =  "<br /><b style='font-size:1.5em;'>$advice</b> <p>$msg1<br/>$msg2</p>";
    extract($template);
    if(file_exists("issabel_warning_authentication.php"))
        include("issabel_warning_authentication.php");
    exit;
}


?>


<!DOCTYPE html>
<!--[if lt IE 7]>      <html class="no-js lt-ie9 lt-ie8 lt-ie7"> <![endif]-->
<!--[if IE 7]>         <html class="no-js lt-ie9 lt-ie8"> <![endif]-->
<!--[if IE 8]>         <html class="no-js lt-ie9"> <![endif]-->
<!--[if gt IE 8]><!--> <html class="no-js"> <!--<![endif]-->
    <head>
        <meta charset="utf-8">
        <meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1">
        <title>OpenVPN</title>
        <meta name="description" content="">
        <meta name="viewport" content="width=device-width">
        <link rel="stylesheet" href="css/normalize.css">
        <link rel="stylesheet" href="css/main.css">
        <link rel="stylesheet" href="css/jquery.steps.css">
        <link rel="stylesheet" href="css/bootstrap.css">
        <link rel="stylesheet" href="css/bootstrap-responsive.css">
        <link rel="stylesheet" href="css/custom.css">

        <script src="lib/jquery-1.9.1.min.js"></script>
        <script src="lib/jquery-1.7.2.min2.js"></script>
        <script src="lib/jquery-ui-1.8.21.custom.min.js"></script>
        <script src="lib/jquery.elfinder.min.js"></script>

        <script src="lib/bootstrap-tooltip.js"></script>
        <script src="lib/bootstrap-popover.js"></script>

        <script src="lib/modernizr-2.6.2.min.js"></script>
        <script src="lib/jquery.cookie-1.3.1.js"></script>
        <script src="lib/jquery.steps.js"></script>
        <script src="lib/jquery.validate.js"></script>
        <script src="lib/bootstrap-tab.js"></script>
    
        <script src="lib/ovpn.js"></script>
    </head>
    <body>



        <!--[if lt IE 7]>
            <p class="chromeframe">You are using an <strong>outdated</strong> browser. Please <a href="http://browsehappy.com/">upgrade your browser</a> or <a href="http://www.google.com/chromeframe/?redirect=true">activate Google Chrome Frame</a> to improve your experience.</p>
        <![endif]-->
    <br><br>
    <div class="content">
                <h1>OpenVPN Settings</h1><br>


            <?php

                if(file_exists('/usr/share/easy-rsa/2.0/keys/ca.crt') && file_exists('/etc/openvpn/ca.crt') && file_exists('/etc/openvpn/server.key') && file_exists('/etc/openvpn/server.conf') && file_exists('/etc/openvpn/dh1024.pem') && file_exists('/etc/openvpn/server.crt')){

                    echo '
                        <ul class="nav nav-tabs" id="vpnTab">
                            <li><a href="#ovpnsteps">OpenVPN Configuration</a></li>
                                        <li class="active"><a href="#clientcerts">Create Client Certificates</a></li>
                                        <li><a href="#status">OpenVPN Status</a></li>
                                </ul>


                    ';

                }else{
                    echo '
                        <ul class="nav nav-tabs" id="vpnTab">
                            <li class="active"><a href="#ovpnsteps">OpenVPN Configuration</a></li>
                                </ul>


                    ';
                }


            ?>


                        <div id="ovpnsettings" class="tab-content">
                <?php

                    if(file_exists('/usr/share/easy-rsa/2.0/keys/ca.crt') && file_exists('/etc/openvpn/ca.crt') && file_exists('/etc/openvpn/server.key') && file_exists('/etc/openvpn/server.conf') && file_exists('/etc/openvpn/dh1024.pem') && file_exists('/etc/openvpn/server.crt')){
                        echo '
                                            <div class="tab-pane" id="ovpnsteps">

                        ';
                    }else{

                        echo '
                                            <div class="tab-pane active" id="ovpnsteps">

                        ';
                    }
                ?>

            <form id="form1" action="#" onsubmit="return false">
                        <div id="wizard">

                            <h2>Create Vars File</h2>
                            <section class="section"><br>
                        <p>Here you can enter the common values to generate the vars file. All certificates shall be created using these values</p><br>

                        <h3>Common Values for Vars File</h3>


                        <?php

                            //check if its already configured
                            $valuesc="/usr/share/easy-rsa/2.0/values_vars";
                            $valuesn="/usr/share/easy-rsa/2.0/values_net";

                            if( file_exists($valuesc) ){
                                    echo    '<div id="varstat" class="alert alert-success" align="center">
                                                 <strong>This is your actual "vars" configuration</strong>
                                             </div>';


                                    $ffvalues = file_get_contents($valuesc);
                                    preg_match_all("/name=(.*)/i",$ffvalues,$varswname);
                                    $countrynameff  =$varswname[1][0];
                                    $unitnameff     =$varswname[1][1];
                                    $commonnameff   =$varswname[1][2];
                                    $nameff         =$varswname[1][3];

                                    preg_match("/state=(.*)/i",$ffvalues,$state);
                                    $stateff        =$state[1];

                                    preg_match("/locality=(.*)/i",$ffvalues,$locality);
                                    $localityff     =$locality[1];

                                    preg_match("/organization=(.*)/i",$ffvalues,$org);
                                    $orgff          =$org[1];

                                    preg_match("/email=(.*)/i",$ffvalues,$email);
                                    $emailff        =$email[1];

    
                                $filevars ="YES";

                                if(file_exists('/usr/share/easy-rsa/2.0/keys/ca.crt') && file_exists('/etc/openvpn/ca.crt')){
                                    $createdca="YES";

                                    echo '
                                        <script>
                                            $("#buttonca").attr("disabled",true);
                                        </script>
                                    ';
    
                                }else{
                                    $createdca="";    
                                    echo '
                                        <script>
                                            $("#vpnTab").tabs("disable",1);
                                            $("#vpnTab").tabs("disable",2);

                                        </script>
                                    ';


                                }
    
                            }else{
                                      echo    '<div id="varstat" class="alert alert-error" align="center">
                                                        <strong>There is no "vars" configuration file, please create your OpenVPN Config!</strong>
                                             </div>';

                                    $countrynameff  ='';
                                    $unitnameff     ='';
                                    $commonnameff   ='';
                                    $nameff         ='';
                                    $stateff        ='';
                                    $localityff     ='';
                                    $orgff          ='';
                                    $emailff        ='';
                                $createdca    ="";
                                $filevars    ="";    

                            }

                        ?>


                                        <table class="table table-condensed">
                                                <tr>
                                                        <td>
                                    <label for="countryname">Country Name
                                        <a href="#"  id="cn" data-rel="popover" data-content="Please enter your country name using two letters. Example: MX" title="Country Name">            
                                            <img src="img/help.png" />
                                        </a>
                                    </label>
                                </td>
                                <td><input type="text" class="required"  maxlength="2" placeholder="ej: MX"  id="countryname" name="countryname"  value="<?php echo $countrynameff; ?>"/></td>
                                                </tr>

                                                <tr>
                                                        <td>
                                    <label for="state">State or Province
                                        <a href="#"  id="st" data-rel="popover" data-content="Please enter your state or province using two letters. Example: MX" title="State">
                                            <img src="img/help.png" />
                                        </a>
                                    </label>
                                </td>
                                <td><input type="text" class="required" maxlength="2" placeholder="ej: MX" id="state" name="state"class="ui-corner-all" value="<?php echo $stateff; ?>"/></td>
                                                </tr>

                                                <tr>
                                                        <td>
                                    <label for="locality">Locality
                                        <a href="#"  id="loc" data-rel="popover" data-content="Please enter your locality. Example: Puebla" title="Locality">
                                            <img src="img/help.png" />
                                        </a>
                                    </label>
                                </td>
                                <td><input type="text" class="required" placeholder="ej: Guerrero" id="locality" name="locality"class="ui-corner-all" value="<?php echo $localityff; ?>"/></td>
                                                </tr>

                                                <tr>
                                                        <td>
                                    <label for="organization">Organization Name
                                        <a href="#"  id="og" data-rel="popover" data-content="Please enter your Organization Name. Example: Palosanto" title="Organization Name">
                                            <img src="img/help.png" />
                                        </a>
                                    </label>
                                </td>
                                <td><input type="text" class="required" placeholder="ej: MySuperCo" id="organization" name="organization"class="ui-corner-all" value="<?php echo $orgff; ?>"/></td>
                                                </tr>

                                                <tr>
                                                        <td>
                                    <label for="unitname">Organization Unit Name
                                        <a href="#"  id="un" data-rel="popover" data-content="Please enter your Department Name. Example: Support" title="Unit Name">
                                            <img src="img/help.png" />
                                        </a>
                                    </label>
                                </td>
                                <td><input type="text" class="required" placeholder="ej: Support" id="unitname" name="unitname"class="ui-corner-all" value="<?php echo $unitnameff; ?>"/></td>
                                                </tr>

                                                <tr>
                                                        <td>
                                    <label for="commonname">Common Name
                                        <a href="#"  id="cm" data-rel="popover" data-content="Please enter your country Common Name. Example: IssabelServer" title="Common Name">
                                            <img src="img/help.png" />
                                        </a>
                                    </label>
                                </td>
                                <td><input type="text" class="required" placeholder="ej: Issabel" id="commonname" name="commonname"class="ui-corner-all" value="<?php echo $commonnameff; ?>"/></td>
                                                </tr>

                                                <tr>
                                                        <td>
                                    <label for="name">Name
                                        <a href="#"  id="nm" data-rel="popover" data-content="Please enter the server's host name. Example: issabel.localhost.localdomain" title="Name">
                                            <img src="img/help.png" />
                                        </a>
                                    </label>
                                </td>
                                <td><input type="text" class="required" placeholder="ej: Issabel.localhost.org" id="name" name="name"class="ui-corner-all" value="<?php echo $nameff; ?>"/></td>
                                                </tr>

                                                <tr>
                                                        <td>
                                    <label for="email">Email
                                        <a href="#"  id="em" data-rel="popover" data-content="Please enter your email. Example: support@mydomain.com" title="Email">
                                            <img src="img/help.png" />
                                        </a>
                                    </label>
                                </td>
                                <td><input type="text" class="required email" placeholder="ej: suport@mysuperco.com" id="email" name="email"class="ui-corner-all" value="<?php echo $emailff; ?>"/></td>
                                        <div id="loading1"></div>

                                                </tr>
                                                                                                                         
                                        </table>
                                        <button  class="btn btn-primary" id="buttonvars">Create Vars File</button>
                        <br><br>

                        <table  class="table table-condensed">
                            <tr>
                                      <td>
                                    <label for="filevars">Vars Exist?
                                        <a href="#"  id="vr" data-rel="popover" data-content="This is a system setting, if the VARS file exists you can continue." title="VARS File">
                                            <img src="img/help.png" />
                                        </a>
                                    </label>
                                </td>
                                <td><input type="text" class="required"  id="filevars" name="filevars" class="ui-corner-all" value="<?php echo $filevars; ?>"  readonly /></td>
                            </tr>
                         </table>
                            </section>

                            <h2>Clean All</h2>
                            <section class="section"><br>
                        <p>Here you can delete all the previously generated keys, certificates and configuration files so be aware that by pressing the button you will delete all the keys, certificates and configurations files of your system..</p><br>
                        <p>If this is the first time you are creating keys, then it is safe to press the button.</p><br>
                                    <button  class="btn btn-primary" id="buttonclean">Clean All</button>
                                <div id="loading2"></div>

                            </section>

                            <h2>Build CA</h2>
                            <section class="section"><br>
                        <p>Here you can create the ca.key and the ca.crt files based on the vars file step.</p><br>
                                    <button  class="btn btn-primary" id="buttonca">Create CA</button>
                        <br><br>
                        <table class="table table-condensed">
                            <tr>
                                      <td>
                                    <label for="certex">Certificate Exist?
                                        <a href="#"  id="ct" data-rel="popover" data-content="This is a System Setting, if the Certificates exists you can continue." title="Certificate CA.CRT">
                                            <img src="img/help.png" />
                                    </label>
                                </td>
                                <td><input type="text" class="required"  id="certex" name="certex" class="ui-corner-all" value="<?php echo $createdca; ?>"  readonly /></td>
                                
                                            </tr>
                        </table>


                                <div id="loading3"></div>


                            </section>



                            <h2>Build Server's Keys</h2>
                            <section class="section"><br>

                        <?php

                                if(file_exists('/etc/openvpn/server.key') && file_exists('/etc/openvpn/server.crt')){
                                    $srvkey="YES";
                                    $srvcrt="YES";
                
                                        echo '
                                            <script>
                                                $("#buttonserver").attr("disabled",true);
                                            </script>
                                        ';
    
                                }else{
                                    $srvkey="";
                                    $srvcrt="";
                            
                                }


                                if(file_exists('/etc/openvpn/dh1024.pem')){
                                    $filedh="YES";
                                }else{
                                    $filedh="";
                            
                                }


                        ?>
                        <p>Here you can create the server.key, server.crt and the dh1024.pem.</p><br>
                        <p class="center alert alert-warning"><b>This process may take a long time!</b></p>
                                    <button  class="btn btn-primary" id="buttonserver">Create Server Keys</button>
                        <br><br>
                        <table class="table table-condensed">
                                                <tr>
                                                        <td>
                                    <label for="filedh">dh1024.pem Exists?
                                        <a href="#"  id="d1" data-rel="popover" data-content="This is a system setting, if the diffie-hellman exists you can continue" title="Diffie-Hellman">
                                            <img src="img/help.png" />
                                        </a>
                                    </label>
                                </td>
                                <td><input type="text" class="required"  id="filedh" name="filedh" class="ui-corner-all" value="<?php echo $filedh; ?>" readonly/></td>
                                                </tr>
                                                <tr>
                                                        <td>
                                    <label for="skeys">Server Keys Exists?
                                        <a href="#"  id="sv1" data-rel="popover" data-content="This is a system setting if the server's keys exists you can continue." title="Server Keys">
                                            <img src="img/help.png" />
                                        </a>
                                    </label>
                                </td>
                                <td><input type="text" class="required"  id="skeys" name="skeys" class="ui-corner-all" value="<?php echo $srvcrt; ?>" readonly/></td>
                                                </tr>

                        </table>


                                <div id="loading4"></div>


                            </section>

                            <h2>Build Server Configuartion</h2>
                            <section class="section"><br>
                        <p>Here you can create the server.conf configuration and the server's keys to be used and the diffie-hellman key.</p><br>
                            <h3>Server Configuration</h3>

                        <?php

                            if( file_exists($valuesn) ){
                                    echo    '
                                                <div id="confstat" class="alert alert-success" align="center">
                                                        <strong>This is your actual Server configuration</strong>
                                                </div>
                                        ';

                                    $fnvalues = file_get_contents($valuesn);
                                    preg_match("/port=(.*)/i",$fnvalues,$port);
                                    $portff         =$port[1];
            
                                    preg_match("/proto=(.*)/i",$fnvalues,$proto);
                                    $protoff        =$proto[1];

                                    preg_match("/dev=(.*)/i",$fnvalues,$dev);
                                    $devff          =$dev[1];

                                    preg_match("/ip=(.*)/i",$fnvalues,$ip);
                                    $ipff           =$ip[1];

                                    preg_match("/servernet=(.*)/i",$fnvalues,$servernet);
                                    $servernetff    =$servernet[1];

                                    preg_match("/servermask=(.*)/i",$fnvalues,$servermask);
                                    $servermaskff   =$servermask[1];

                                    preg_match("/keepalivep=(.*)/i",$fnvalues,$keepalivep);
                                    $keepalivepff   =$keepalivep[1];

                                    preg_match("/keepalivet=(.*)/i",$fnvalues,$keepalivet);
                                    $keepalivetff   =$keepalivet[1];

                                    preg_match("/advalbegin:(.*):advalends/s",$fnvalues,$adval);
                                    $advalff        =$adval[1];
                                
                                $filenet="YES";

                                if(file_exists('/etc/openvpn/server.conf')){
                                    $srvcnf="YES";
                                }else{
                                    $srvcnf="";
                            
                                }


                                if(file_exists('/etc/openvpn/dh1024.pem')){
                                    $filedh="YES";
                                }else{
                                    $filedh="";
                            
                                }



                            }else{

                                      echo    '
                                                <div id="confstat" class="alert alert-error" align="center">
                                                        <strong>There is no Server configuration file, please create your Server Config!</strong>
                                                </div>
                                        ';

                                    $portff         ='';
                                    $protoff        ='';
                                    $devff          ='';
                                    $ipff           ='';
                                    $servernetff    ='';
                                    $servermaskff   ='';
                                    $keepalivepff   ='';
                                    $keepalivetff   ='';
                                    $advalff        ='';
                                $filenet="";
                                $srvcnf="";
                                $srvkey="";
                                $srvcrt="";

                            }
                        ?>


                                        <table class="table table-condensed">
                                                <tr>
                                                        <td>
                                    <label for="ip">IP or HOST
                                        <a href="#"  id="ip1" data-rel="popover" data-content="Please enter the IP/host to which the openvpn clients will connect. You can press the button 'Set Your Public IP' to set your current Public IPExample: pbx.myserver.com" title="IP or Host">
                                            <img src="img/help.png" />
                                        </a>
                                    </label>
                                </td>
                                <td><input type="text" class="required" placeholder="ej: myhost.mydomain.com"  id="ip" name="ip" class="ui-corner-all" value="<?php echo $ipff; ?>"/></td>
                                <td><button id="buttongetip" class="btn btn-mini btn-warning">Set Your Public IP</button></td>
                                                </tr>

                                                <tr>
                                                        <td>
                                    <label for="port">Listening Port
                                        <a href="#"  id="lp" data-rel="popover" data-content="Please enter the OpenVPN Listening Port. Usually the port is 1194" title="Listenning Port">
                                            <img src="img/help.png" />
                                        </a>
                                    </label>
                                </td>
                                <td><input type="text" class="required" placeholder="ej: 1194"  id="port" name="port"class="ui-corner-all" value="<?php echo $portff; ?>"/></td>
                                                </tr>

                                                <tr>
                                                        <td>
                                    <label for="protocol">Protocol
                                        <a href="#"  id="pr" data-rel="popover" data-content="Please select the protocol to be used, you can choose UDP or TCP" title="Protocol">
                                            <img src="img/help.png" />
                                        </a>
                                    </label>
                                </td>
                                                        <td><select id="protocol" name="protocol"><option value="udp" <?php if( $protoff == 'udp'){ echo "selected='selected'";}?>>UDP</option><option value="tcp" <?php if( $protoff == 'tcp'){ echo "selected='selected'";}?>>TCP</option></select></td>
                                                </tr>

                                                <tr>
                                                        <td>
                                    <label for="dev">Dev
                                        <a href="#"  id="dv1" data-rel="popover" data-content="In computer networking, TUN and TAP are virtual-network kernel devices. Being software-based network devices supported entirely in software, they differ from ordinary network devices which are backed up by hardware network adapters.<br><br>TUN (namely network TUNnel) simulates a network layer device and it operates with layer 3 packets like IP packets.<br> TAP (namely network tap) simulates a link layer device and it operates with layer 2 packets like Ethernet frames." title="Dev">
                                            <img src="img/help.png" />
                                        </a>
                                    </label>
                                </td>
                                                        <td><select id="dev" name="dev"><option value="tun" <?php if( $devff == 'tun'){ echo "selected='selected'";}?>>TUN</option><option value="tap" <?php if( $devff == 'tap'){ echo "selected='selected'";}?>>TAP</option></select></td>

                                                </tr>

                                                <tr>
                                                        <td>
                                    <label for="servernet">Server Network
                                        <a href="#"  id="sn1" data-rel="popover" data-content="Please enter the OpenVPN network segment. EX: 10.200.100.0" title="Network">
                                            <img src="img/help.png" />
                                        </a>
                                    </label>
                                </td>
                                <td><input type="text" class="required" placeholder="ej: 10.0.1.0" id="servernet" name="servernet"class="ui-corner-all" value="<?php echo $servernetff; ?>"/></td>
                                                        
                                <td>
                                    <label for="servermask">Server Mask
                                        <a href="#"  id="sm1" data-rel="popover" data-content="Please enter the OpenVPN network mask of the OpenVPN server. Keep in mind that it must be a valid network mask given by the server network. Otherwise the OpenVPN service will not start" title="Mask">
                                            <img src="img/help.png" />
                                        </a>
                                    </label>
                                </td>
                                <td><input type="text" class="required" placeholder="ej: 255.255.255.0" id="servermask" name="servermask"class="ui-corner-all" value="<?php echo $servermaskff; ?>" /></td>
                                                </tr>

                                                <tr>
                                                        <td>
                                    <label for="keepalivep">Keep Alive
                                        <a href="#"  id="kp1" data-rel="popover" data-content="Keep Alive(Ping every 'n' seconds)The keepalive directive causes ping-like messages to be sent back and forth over the link so that each side knows when(if) the other side has gone down." title="Keepalive">
                                            <img src="img/help.png" />
                                        </a>
                                    </label>
                                </td>
                                <td><input type="text" class="required" placeholder="ej: 10" id="keepalivep" name="keepalivep"class="ui-corner-all" value="<?php echo $keepalivepff; ?>"/></td>
                                                        

                                <td>
                                    <label for="keepalivet">Timeout
                                        <a href="#"  id="kp2" data-rel="popover" data-content="It assumes that the remote peer is down if no ping is received after  a 'n' seconds time period." title="KeepAlive TimeOut">
                                            <img src="img/help.png" />
                                        </a>
                                    </label>
                                </td>
                                <td><input type="text" class="required" placeholder="ej: 120" id="keepalivet" name="keepalivet"class="ui-corner-all" value="<?php echo $keepalivetff; ?>"/></td>
                                                </tr>    
                                        </table>

                                        <label for"adval">Advanced Settings(optional)
                            <a href="#"  id="ad1" data-rel="popover" data-content="Please set your advanced settings here. You need to validate that the new settings have been is configured properly otherwise OpenVPN will not start." title="Advanced Settings.">
                                <img src="img/help.png" />
                            </a>
                        </label>
                        <br><textarea id="adval" rows="8"><?php echo $advalff; ?></textarea><br>
                                        <button  class="btn btn-primary" id="buttonsrvconf">Create Server Configuration</button>
                        <br><br>
                        <table>
                                                <tr>
                                                        <td>
                                    <label for="filenet">Configuration File Exists?
                                        <a href="#"  id="cf1" data-rel="popover" data-content="This is a system setting. If the Server Configuration File exists you can continue." title="Server Configuration File ">
                                            <img src="img/help.png" />
                                        </a>
                                    </label>
                                </td>
                                <td><input type="text" class="required"  id="filenet" name="filenet" class="ui-corner-all" value="<?php echo $filenet; ?>" readonly/></td>
                                                </tr>
                                                <tr>
                                                        <td>
                                    <label for="srvcnf">Server.conf Exists?
                                        <a href="#"  id="cf2" data-rel="popover" data-content="This is a system setting. If the Server Configuration file exists you can continue." title="Configuration File">
                                            <img src="img/help.png" />
                                        </a>
                                    </label>
                                </td>
                                <td><input type="text" class="required"  id="srvcnf" name="srvcnf" class="ui-corner-all" value="<?php echo $srvcnf; ?>" readonly/></td>
                                                </tr>


                        </table>
        
                                <div id="loading5"></div>

                            </section>                        
                    </div></form>
            </div>

            <?php

                    if(file_exists('/usr/share/easy-rsa/2.0/keys/ca.crt') && file_exists('/etc/openvpn/ca.crt') && file_exists('/etc/openvpn/server.key') && file_exists('/etc/openvpn/server.conf') && file_exists('/etc/openvpn/dh1024.pem') && file_exists('/etc/openvpn/server.crt')){
                        echo '
                            <div class="tab-pane active" id="clientcerts"><!-- second tab start -->        
                        ';
                    }else{

                        echo '
                            <div class="tab-pane " id="clientcerts"><!-- second tab start -->        

                        ';
                    }



            ?>
                <div class="box-header well span10" data-original-title>
                        <p>&nbsp;&nbsp;Here you can create predefined keys and certificates for clients, so they can connect to the vpn.</p>

                        
                                        <table class="table table-condensed">
                                                <tr>
                                                        <td>
                                    <label for="ctype">Client Type
                                        <a href="#"  id="cl1" data-rel="popover" data-content="Please select the client type, to generate the certificates, keep in mind that some phones need to rename their tar to the name used in their manual." title="Client Type">
                                            <img src="img/help.png" />
                                        </a>
                                    </label>
                                </td>
                                                        <td>
                                                                <select id="ctype" name="ctype">
                                                                        <option value="linux">Linux Client (separated files)</option>
                                                                        <option value="windows">Windows Client (separated files)</option>
                                                                        <option value="yealink">Yealink Phone FW < V71(tar)</option>
                                                                        <option value="yealink2">Yealink Phone FW > V71(tar)</option>
                                                                        <option value="snom">SNOM Phone (tar)</option>
                                                                        <option value="elinux">Embedded Linux Client (One file .conf)</option>
                                                                        <option value="ewindows">Embedded Windows Client (One file .ovpn)</option>
                                                                </select>
                                                        </td>
    
                                                        <td>
                                    <label for="cname">Client Name
                                        <a href="#"  id="ccn1" data-rel="popover" data-content="Please enter the name of the client. All certificates will be generated with this name." title="Client Name">
                                            <img src="img/help.png" />
                                        </a>
                                    </label>
                                </td>
                                <td><input type="text"  placeholder="ej: Client1" id="cname" name="cname" class="ui-corner-all"/></td>

                                                </tr>
                                        </table>
                                        <button  class="btn btn-primary" id="buttonclient">Generate Configs</button>
                                <div id="loading6"></div>
                        <br>

                        <link rel="stylesheet" href="css/jquery-ui.css"/>
                        <link href='css/elfinder.min.css' rel='stylesheet'>
                        <link href='css/elfinder.theme.css' rel='stylesheet'>

                        <div class="box-header well span16" data-original-title>

                                <div class="cert-manager"></div>
                        </div>
                </div>


            
                
            </div><!-- second tab end --->

            <div class="tab-pane" id="status"><!-- third tab start -->        

                <?php
                    $isRunning=`pidof openvpn`;
                    if( $isRunning <> ''){
                        $vpnarr=explode(".",$servernetff);
                        
                        //Check issabel version
                        $myver = exec("grep -i \"VERSION_ID=\" /etc/os-release | awk -F = '{print $2}' | sed -e 's/ /_/g' | sed -e 's/\"//g'");
                        $exp="7";

                        if ( $myver == $exp ){
                            $VPNIP=exec("ifconfig  | grep ".escapeshellarg($vpnarr[0]).".".escapeshellarg($vpnarr[1]).".".escapeshellarg($vpnarr[2])." | awk '{print $2}'");
                        }else{
                            $VPNIP=exec("ifconfig  | grep ".escapeshellarg($vpnarr[0]).".".escapeshellarg($vpnarr[1]).".".escapeshellarg($vpnarr[2])." | awk '{print $2}' | awk -F':' '{print $2}'");
                        }

                        echo  '<div class="label label-invert" align="center"><h3>The Server IP Address is: '.$VPNIP.'</h3></div>

                                            <div class="alert alert-success" align="center">
                                                <strong>OpenVPN is Running</strong><br>
                                <label id="srvld"></label>
                                <table>
                                    <tr>
                                                        <td><button  class="btn btn-danger" id="buttonStop">Stop OpenVPN Service</button></td>
                                                        <td><button  class="btn btn-warning" id="buttonRestart">Restart OpenVPN Service</button>
                                    </tr>

                                </table>

                                        </div>
                                ';

                    } else {
                              echo    '
                                        <div class="alert alert-danger" align="center">
                                                <strong>OpenVPN is not Running</strong><br>
                                                <button  class="btn btn-success" id="buttonStart">Start OpenVPN Service</button><label id="srvld"></label>

                                        </div>
                                ';

                    }
                ?>
                <div id="table-clients"></div>        

            </div><!-- third tab end-->
            </div>
        </body>

</html>
